const canvas = document.getElementById("myCanvas");
const ctx = canvas.getContext("2d");

let x,y;
let v;
let dv;
let av;
let f;
let r,l,m,op;
let a,b,c,e;

let buffer = null;
let d = { width: canvas.width, height: canvas.height };

function init() {
    d = { width: canvas.width, height: canvas.height };
	
		f=1;
		v=0;
		av=3;	
		dv=av;
		r=15;
		l=240;
		m=3;
		a=1000;
		b=1000;
		op=180;
		c=1;
		e=-1;	
		
    buffer = createBuffer(d.width, d.height);
    drawToBuffer();
}

function createBuffer(width, height) {
    const offscreenCanvas = document.createElement('canvas');
    offscreenCanvas.width = width;
    offscreenCanvas.height = height;
    return offscreenCanvas;
}

function drawToBuffer() {
    const g = buffer.getContext("2d");
    g.fillStyle = "white";
    g.fillRect(0, 30, d.width, d.height - 30);
    g.strokeStyle = "black";
    g.beginPath();
    g.moveTo(op,30);
    g.lineTo(op, d.height);
    g.moveTo(0, (d.height / 2));
    g.lineTo(d.width, (d.height / 2) );
    g.stroke();
	if (e==-1){	g.fillStyle = "yellow";}
	if (e==1){	g.fillStyle = "gray";}	
    g.fillRect(op+(2*m+c)*l/4,30, 40, d.height );

    for (x = 0; x <=op+(2*m+c)*l/4; x = x + r) {
        y = (d.height / 6) * e*Math.sin((x + v-op) * 2 * Math.PI / l) + (d.height / 2)+a;
        g.fillStyle = "lightgreen" ;
        g.beginPath();
        g.arc(x, y, r /2, 0, Math.PI * 2);
        g.fill();
    }

    for (x = 0; x <=op+(2*m+c)*l/4; x = x + r) {
        y =  (d.height / 6) *Math.sin((v-x+op) * 2 * Math.PI / l) + (d.height / 2);
        g.fillStyle = (x === op) ? "red" : "blue";
		 g.beginPath();
        g.arc(x, y, r /2, 0, Math.PI * 2);
        g.fill();
       
    }
	for (x = 0; x <=op+(2*m+c)*l/4; x = x + r) {
        y = b+(d.height / 6) * e*Math.sin((x + v-op) * Math.PI *2/ l)+ 
		(d.height / 6)*Math.sin((-x + v+op)*2* Math.PI / l)+ (d.height / 2);
        g.fillStyle = "red" ;
        g.beginPath();
        g.arc(x, y, r /2, 0, Math.PI * 2);
        g.fill();
    }
}

function move() {
    dv = f * av;
    v = v + dv;
}

function start() {
    setInterval(function() {
        move();
        drawToBuffer();
        ctx.clearRect(0, 0, canvas.width, canvas.height);
        ctx.drawImage(buffer, 0, 0);
    }, 30);
}

document.getElementById('free').addEventListener('click', free);
document.getElementById('fixed').addEventListener('click', fixed);
document.getElementById('inci').addEventListener('click', inci);
document.getElementById('ref').addEventListener('click', ref);
document.getElementById('compo').addEventListener('click', compo);
document.getElementById('sh').addEventListener('click', sh);
document.getElementById('sm').addEventListener('click', sm);
document.getElementById('sl').addEventListener('click', sl);
document.getElementById('sS').addEventListener('click', sS);
document.getElementById('sL').addEventListener('click', sL);
document.getElementById('stop').addEventListener('click', stop);
document.getElementById('run').addEventListener('click', run);


function free() {
        c=1;
		e=-1;
}
function fixed() {
       c=1;
		e=1;
}
function inci() {
        a=1000;
		b=1000;
}
function ref() {
        a=0;
		b=1000;
}
function compo() {
        a=0;
		b=0;
}
function sh() {
        av=5;
}
function sm() {
        av=3;
}
function sl(){
        av=2;
}
function sS() {
       r=10;
}
function sL() {
        r=15;
}
function stop() {
        av=0;
}
function run() {
        av=3;
}


init();
start();




